﻿<AML>
 <Item type="Method" id="A81069CBD7CC4C388A7EA7A620B3826D" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_transfer_unload_call
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Adding Journal and CashBook for CashBook Transfering.

            Hooks:
                Called by:	acc_transfer_unload

            Inputs:
                _id,
                is_valid,
                acc_from_account,
                acc_to_account,
                acc_from_balance,
                acc_to_balance,
                acc_transfer_amount,
                acc_transfer_date,
                acc_from_currency,
                acc_to_currency

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_transfer_unload_call";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getProperty("_id", "");
                var is_valid = this.getProperty("is_valid", "");
                var acc_from_currency = this.getProperty("acc_from_currency", "");
                var acc_to_currency = this.getProperty("acc_to_currency", "");
                var acc_from_account = this.getProperty("acc_from_account", "");
                var acc_to_account = this.getProperty("acc_to_account", "");
                var acc_from_balance = this.getProperty("acc_from_balance", "");
                var acc_to_balance = this.getProperty("acc_to_balance", "");
                var acc_transfer_amount = this.getProperty("acc_transfer_amount", "");
                var acc_transfer_date = this.getProperty("acc_transfer_date", "");
                string _isentry = "";
                string _headerid = "";
                string _cashbook_header_id = "";
                string _cashbook_header_id_1 = "";
                
                Item acc_CBT = myInnovator.newItem("ACC_CASHBOOKTRANSFER", "get");
                acc_CBT.setProperty("id", _id);
                acc_CBT.setPropertyCondition("id", "eq");
                Item acc_CBT_res = acc_CBT.apply();
                var CBT_count = acc_CBT_res.getItemCount();
                if (CBT_count > 0)
                {
                    for (var i = 0; i < CBT_count; i++)
                    {
                        var acc_CBTs = acc_CBT_res.getItemByIndex(i);
                        acc_from_account = acc_CBT_res.getProperty("acc_from_account");
                        acc_to_account = acc_CBT_res.getProperty("acc_to_account");
                        acc_from_balance = acc_CBT_res.getProperty("acc_from_balance");
                        acc_to_balance = acc_CBT_res.getProperty("acc_to_balance");
                        acc_transfer_amount = acc_CBT_res.getProperty("acc_transfer_amount");
                        acc_transfer_date = acc_CBT_res.getProperty("acc_transfer_date");
                    }
                }
                Item update_ap = myInnovator.applySQL("Update innovator.[ACC_CASHBOOKTRANSFER] set  acc_ispost=" + 1 + " WHERE id='" + _id + "'");

                decimal d_from_balance = Convert.ToDecimal(acc_from_balance);
                decimal d_to_balance = Convert.ToDecimal(acc_to_balance);
                decimal d_transfer_amount = Convert.ToDecimal(acc_transfer_amount);
                decimal d_decrease_balance = d_from_balance - d_transfer_amount;
                decimal d_increase_balance = d_to_balance + d_transfer_amount;
               
                if (_isentry == "")
                {
                    Item acc_Ledger_Add_CT = myInnovator.newItem("ACC_JOURNAL_HEADER", "add");
                    acc_Ledger_Add_CT.setProperty("acc_date", acc_transfer_date);
                    acc_Ledger_Add_CT.setProperty("acc_reftransactionid", _id);
                    acc_Ledger_Add_CT.setProperty("acc_transactiontype", "CashBook Transfer");
                    acc_Ledger_Add_CT.apply();
                    _headerid = acc_Ledger_Add_CT.getID();
                    if (acc_Ledger_Add_CT.isError())
                    {
                        return myInnovator.newError("Error In Save1: " + acc_Ledger_Add_CT.getErrorDetail());
                    }
                    _isentry = "1";
                }

                Item acc_Ledger_Add_Detail_Dr = myInnovator.newItem("ACC_JOURNAL_DETAILS", "add");
                acc_Ledger_Add_Detail_Dr.setProperty("acc_accountid", acc_from_account);
                acc_Ledger_Add_Detail_Dr.setProperty("acc_credit", Convert.ToString(acc_transfer_amount));
                acc_Ledger_Add_Detail_Dr.setProperty("acc_debit", "0");
                acc_Ledger_Add_Detail_Dr.setProperty("acc_systemaccountid", "CashBook");
                acc_Ledger_Add_Detail_Dr.setProperty("acc_currency", acc_from_currency);
                acc_Ledger_Add_Detail_Dr.setProperty("acc_amount_currency", Convert.ToString(acc_transfer_amount));
                acc_Ledger_Add_Detail_Dr.setProperty("source_id", _headerid);
                acc_Ledger_Add_Detail_Dr.apply();

                Item acc_Ledger_Add_Detail_Cr = myInnovator.newItem("ACC_JOURNAL_DETAILS", "add");
                acc_Ledger_Add_Detail_Cr.setProperty("acc_accountid", acc_to_account);
                acc_Ledger_Add_Detail_Cr.setProperty("acc_credit", "0");
                acc_Ledger_Add_Detail_Cr.setProperty("acc_debit", Convert.ToString(acc_transfer_amount));
                acc_Ledger_Add_Detail_Cr.setProperty("acc_systemaccountid", "CashBook");
                acc_Ledger_Add_Detail_Cr.setProperty("acc_currency", acc_to_currency);
                acc_Ledger_Add_Detail_Cr.setProperty("acc_amount_currency", Convert.ToString(acc_transfer_amount));
                acc_Ledger_Add_Detail_Cr.setProperty("source_id", _headerid);
                acc_Ledger_Add_Detail_Cr.apply();

                //decrease at from_account
                Item acc_decrease_item = myInnovator.applySQL("Update innovator.[acc_AccountDetails]  set  acc_amount=" + d_decrease_balance + " WHERE id='" + acc_from_account + "'");

                Item acc_cashbook_header = myInnovator.newItem("acc_cashbook", "get");
                acc_cashbook_header.setProperty("acc_cashbook", acc_from_account);
                acc_cashbook_header = acc_cashbook_header.apply();
                var cashbook_count = acc_cashbook_header.getItemCount();
                if (cashbook_count < 1)
                {
                    Item acc_cashbook_add = myInnovator.newItem("acc_cashbook", "add");
                    acc_cashbook_add.setProperty("acc_cashbook", acc_from_account);
                    acc_cashbook_add.setProperty("acc_date", DateTime.Now.ToString("yyyy-MM-dd"));
                    acc_cashbook_add.apply();
                    _cashbook_header_id = acc_cashbook_add.getID();

                    decimal d_acc_decrease_balance = Convert.ToDecimal(d_decrease_balance);
                    decimal d_from_transfer_amt = Convert.ToDecimal(acc_transfer_amount);
                    decimal d_result = d_acc_decrease_balance + d_from_transfer_amt;

                    Item acc_cashbook_Detail_OP = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                    acc_cashbook_Detail_OP.setProperty("acc_account_code", acc_from_account);
                    acc_cashbook_Detail_OP.setProperty("acc_income", Convert.ToString(d_result));
                    acc_cashbook_Detail_OP.setProperty("acc_transaction_date", acc_transfer_date);
                    acc_cashbook_Detail_OP.setProperty("acc_transaction_type", "CashBook Opening");
                    acc_cashbook_Detail_OP.setProperty("source_id", _cashbook_header_id);
                    acc_cashbook_Detail_OP.apply();

                }
                else
                {
                    _cashbook_header_id = acc_cashbook_header.getProperty("id");
                }
                Item acc_cashbook_Detail = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                acc_cashbook_Detail.setProperty("acc_account_code", acc_from_account);
                acc_cashbook_Detail.setProperty("acc_expense", Convert.ToString(acc_transfer_amount));
                acc_cashbook_Detail.setProperty("acc_transaction_id", _id);
                acc_cashbook_Detail.setProperty("acc_transaction_date", acc_transfer_date);
                acc_cashbook_Detail.setProperty("acc_transaction_type", "Cashbook Transfer");
                acc_cashbook_Detail.setProperty("source_id", _cashbook_header_id);
                acc_cashbook_Detail.apply();
                //cashbook adding finish
                Item acc_cashbook_balance = myInnovator.applySQL("Update innovator.[acc_cashbook]  set acc_date='" + DateTime.Now.ToString("yyyy-MM-dd") + "' ,  acc_cashbook_balance=" + d_decrease_balance + " WHERE acc_cashbook='" + acc_from_account + "'");

                // increase at to_account
                Item acc_increase_item = myInnovator.applySQL("Update innovator.[acc_AccountDetails]  set  acc_amount=" + d_increase_balance + " WHERE id='" + acc_to_account + "'");

                Item acc_cashbook_header_1 = myInnovator.newItem("acc_cashbook", "get");
                acc_cashbook_header_1.setProperty("acc_cashbook", acc_to_account);
                acc_cashbook_header_1 = acc_cashbook_header_1.apply();
                var cashbook_count_1 = acc_cashbook_header_1.getItemCount();
                if (cashbook_count_1 < 1)
                {
                    Item acc_cashbook_add_1 = myInnovator.newItem("acc_cashbook", "add");
                    acc_cashbook_add_1.setProperty("acc_cashbook", acc_to_account);
                    acc_cashbook_add_1.setProperty("acc_date", DateTime.Now.ToString("yyyy-MM-dd"));
                    acc_cashbook_add_1.apply();
                    _cashbook_header_id_1 = acc_cashbook_add_1.getID();

                    decimal d_acc_increase_balance = Convert.ToDecimal(d_increase_balance);
                    decimal d_to_transfer_amt = Convert.ToDecimal(acc_transfer_amount);
                    decimal d_result_1 = d_acc_increase_balance - d_to_transfer_amt;

                    Item acc_cashbook_Detail_OP_1 = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                    acc_cashbook_Detail_OP_1.setProperty("acc_account_code", acc_to_account);
                    acc_cashbook_Detail_OP_1.setProperty("acc_income", Convert.ToString(d_result_1));
                    acc_cashbook_Detail_OP_1.setProperty("acc_transaction_date", acc_transfer_date);
                    acc_cashbook_Detail_OP_1.setProperty("acc_transaction_type", "CashBook Opening");
                    acc_cashbook_Detail_OP_1.setProperty("source_id", _cashbook_header_id_1);
                    acc_cashbook_Detail_OP_1.apply();
                }
                else
                {
                    _cashbook_header_id_1 = acc_cashbook_header_1.getProperty("id");
                }
                Item acc_cashbook_Detail_1 = myInnovator.newItem("ACC_CASHBOOKDETAIL", "add");
                acc_cashbook_Detail_1.setProperty("acc_account_code", acc_to_account);
                acc_cashbook_Detail_1.setProperty("acc_income", Convert.ToString(acc_transfer_amount));
                acc_cashbook_Detail_1.setProperty("acc_transaction_id", _id);
                acc_cashbook_Detail_1.setProperty("acc_transaction_date", acc_transfer_date);
                acc_cashbook_Detail_1.setProperty("acc_transaction_type", "Cashbook Transfer");
                acc_cashbook_Detail_1.setProperty("source_id", _cashbook_header_id_1);
                acc_cashbook_Detail_1.apply();
                //cashbook adding finish
                Item acc_cashbook_balance_1 = myInnovator.applySQL("Update innovator.[acc_cashbook]  set acc_date='" + DateTime.Now.ToString("yyyy-MM-dd") + "' ,  acc_cashbook_balance=" + d_increase_balance + " WHERE acc_cashbook='" + acc_to_account + "'");
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_transfer_unload_call</name>
 </Item>
</AML>